#/p/perl/perl -w
#
# Template for writing an agent.
#
# PLEASE NOTE: THIS FILE DOES NOT RUN AS IS, OR EVEN COMPILE. THERE
#              ARE A LOT OF "FILL-IN-THE-BLANKS" PLACES. REFER TO THE
#              GUIDE TO WRITING AGENTS FOR DETAILS.
#
# Search for "%%" to locate the places where you have to fill in the
# blanks.
# 
# AAFID project, COAST Laboratory, 1998.
# 
# Diego Zamboni, Mar 16, 1998.
#
# $Id: Template.pm,v 1.1.1.1 1998/08/12 22:11:35 zamboni Exp $
# $Log: Template.pm,v $
# Revision 1.1.1.1  1998/08/12 22:11:35  zamboni
# AAFID2 prototype as released to COAST sponsors.
#
# Revision 1.1  1998/05/02 19:56:57  zamboni
# Initial revision
#
#
# NOTE: This file is in Perl's POD format. For more information, see the 
#       manual page for perlpod(1).
#

package %%yourAgentName%%;

# The following makes the agent version number keep up with the RCS
# version number. The self-assignment at the end keeps the -w switch
# from complaining (because $VERSION may not be used here, but it is
# used in our base class).
$VERSION = do { my @r = (q$Revision: 1.1.1.1 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r }; $VERSION = $VERSION;

########################################################################
# AGENT PARAMETERS
# Important, set them here

%PARAMETERS=(
	     Description	=> "%%Your agent description here%%",
	     # CheckPeriod may be omitted, it defaults to 10 seconds.
	     CheckPeriod	=> %%your agent check period%%,  # Seconds
	    );

########################################################################

# This is optional; you may remove it, but don't, it will save your
# life some day.
use strict;
use AAFID::Agent;
use AAFID::Log;
%%any other packages you need go here%%

use vars qw(
	    @ISA
	    $VERSION
	    %PARAMETERS
	   );

# Define the superclasses of our agent.
@ISA=qw(AAFID::Agent
	AAFID::Log);

=head1 Description

%% Please use the POD format to document your agent. At least, include a
%% description section, and if the code is complex, also documentation
%% for it. At least, use standard comments. As Larry Wall would say
%% "consider the mental welfare of the person who has to maintain the
%% code after you" :-)

=head1 Implementation

Here we go.

=cut

sub Init {
  my $self=checkref(shift);

  %% Your initialization code goes here. It is optional, if your agent
  %% does not need any specific initialization, simply do not define this
  %% subroutine.

}

sub Check {
  my $self=checkref(shift);

  %% Your checking code here. This subroutine _is_ mandatory. Do whatever
  %% you want, but keep in mind:
  %% - Try not to take to long.
  %% - Use the setParameter and getParameter (see the documentation)
  %%   to keep state, and not any other mechanism.
  %% - Use the Log package to generate log messages.

  %% At the end, return a two element list with something like this:
  return ($status, $message);
  %% where $status is a number from 0 to 10, and $message is a textual
  %% description of the situation.

}

# This is very important. Don't forget it, and it has to be the last
# thing in your file.
_EndOfEntity;
